<?php

namespace Drupal\commerce_opp\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides global settings for commerce_opp module.
 */
class CommerceOppSettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'commerce_opp_settings';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['commerce_opp.settings'];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('commerce_opp.settings');

    $form['encryption_secret'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Webhooks encryption secret'),
      '#default_value' => $config->get('encryption_secret'),
      '#description' => $this->t('The webhooks encryption secret. Only needed, if you are going to use webhooks. See the README.md file for more information on webhooks.'),
      '#size' => 78,
    ];

    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    /** @var \Drupal\Core\Config\Config $config */
    $config = $this->config('commerce_opp.settings');
    $config
      ->set('encryption_secret', $form_state->getValue('encryption_secret'))
      ->save();

    parent::submitForm($form, $form_state);
  }

}
